# Telecamera

# DATI
param nQ;
set Q := 1..nQ;
param xa {Q};
param ya {Q};
param xb {Q};
param yb {Q};
param delta;
param L;
param c {i in Q} := sqrt((xa[i]-xb[i])^2+(ya[i]-yb[i])^2);

# VARIABILI
var xP >=delta, <=L-delta, :=L/2;
var yP >=delta, <=L-delta, :=L/2;
var a {i in Q} = sqrt((xP-xa[i])^2 + (yP-ya[i])^2);
var b {i in Q} = sqrt((xP-xb[i])^2 + (yP-yb[i])^2);
var alfa {Q} >=0, <=3.14;
var alfamin;

# OBIETTIVI
# Tizio: massimizzare somma degli angoli
maximize zTizio: sum {i in Q} alfa[i];
# Caio: massimizzare angolo minimo
#maximize zCaio: alfamin;
subject to Maxmin {i in Q}:
  alfamin <= alfa[i];

# VINCOLI
subject to Carnot {i in Q}:
  c[i]^2 = a[i]^2 + b[i]^2 - 2 * a[i] * b[i] * cos(alfa[i]);

###############
data;

param nQ := 3;
param delta := 1;
param L := 16;

param:  xa  ya  xb  yb :=
1        0   0   0   4
2        0  10   6  16
3       10   0  15   0;

end;
